#include <cassert>
#include <cinttypes>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
#include <string.h>
#include <algorithm>
#include <cmath>
#include <cstdio>

typedef int8_t i8;
typedef int16_t i16;
typedef uint8_t ui8;
typedef uint16_t ui16;
typedef uint32_t ui32;
typedef int32_t i32;
typedef uint64_t ui64;
typedef int64_t i64;

constexpr ui64 INF = 1e18;

constexpr int alpabet_number = 26;

char str[5000001];
ui16 pr[5000001][alpabet_number];
std::vector<int> alp(alpabet_number);
int my_alp[alpabet_number];
int bad[alpabet_number];

void solve(int from, int to) {
    for (int i = 0; i < alpabet_number; ++i) {
        bad[i] = pr[to - 1][i] - (from ? pr[from - 1][i] : 0);
    }
}

int main(void) {
    scanf("%s", str);
    int n = strlen(str);
    for (int i = 0; i < n; ++i) {
        alp[str[i] - 'a']++;
        pr[i][str[i] - 'a'] = 1;
        if (i) {
            for (int j = 0; j < alpabet_number; ++j) {
                pr[i][j] += pr[i - 1][j];
            }
        }
    }
    int gcd_all = n;
    for (int i = 0; i < alpabet_number; ++i) {
        if (str[i] != 0) {
            gcd_all = std::__gcd(gcd_all, alp[i]);
        }
    }
    auto m = (int)std::sqrt(gcd_all) + 10;
    std::vector<int> div;
    for (int i = 1; i < m; ++i) {
        if (gcd_all % i == 0) {
            div.push_back(i);
            div.push_back(n / i);
        }
    }

    std::sort(div.rbegin(), div.rend());
    int ans = 1;
    for (auto& divisor : div) {
        auto c = n / divisor;
        // std::cout << n << " " << divisor << std::endl;
        // std::cout << c << std::endl;

        for (int i = 0; i < alpabet_number; ++i) {
            my_alp[i] = alp[i] / divisor;
        }
        int f = 0;
        for (int i = 0; i < n; i += c) {
            solve(i, i + c);
            if (memcmp(bad, my_alp, alpabet_number * sizeof(int))) {
                f = 1;
                break;
            }
        }
        if (!f) {
            printf("%d\n", divisor);
            return 0;
        }
    }
    printf("%d\n", ans);
    return 0;
}
