#include <algorithm>
#include <iostream>
#include <string>
#include <cstring>
#include <stack>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <numeric>

using namespace std;

#ifdef __APPLE__
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...)
#endif

const int N = (int)5e6 + 1;
const int MOD = (int)1e9 + 7;
const int inf = (int)5e8;
const long long infll = (long long)1e17;

int BASE = 255;

int mul(int a, int b) {
    return (a * 1ll * b) % MOD;
}

int add(int a, int b) {
    long long r = a * 1ll + b;
    if (r >= MOD) {
        r -= MOD;
    }
    if (r < 0) {
        r += MOD;
    }
    return r;
}

string s;
int sum[N];


void solve() {
    cin >> s;
    size_t size = s.size();
    vector<int> deg(27);
    deg[0] = 1;
    for (int i = 1; i < 27; ++i) {
        deg[i] = mul(deg[i - 1], BASE);
    }

    for (size_t i = 1; i <= size; ++i) {
        sum[i] = add(sum[i - 1], deg[s[i - 1] - 'a' + 1]);
    }

    for (size_t len = 1; len <= size; ++len) {
        if (size % len == 0) {
            size_t  cnt = size / len;
            int global = -1;
            bool ok = true;
            for (size_t i = 0; i < cnt; ++i) {
                size_t offset = i * len;
                int hsh = add(sum[offset + len], -sum[offset]);
                if (global == -1) {
                    global = hsh;
                } else if (global != hsh) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                cout << cnt << endl;
                return;
            }
        }
    }

    assert(false);
}


int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    BASE = 255 + rand() % 133;
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
