#include <algorithm>
#include <iostream>
#include <string>
#include <cstring>
#include <stack>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <numeric>

using namespace std;

#ifdef __APPLE__
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...)
#endif

const int N = (int)1e6 + 123;
const int MOD = (int)1e9 + 7;
const int inf = (int)5e8;
const long long infll = (long long)1e17;

int BASE = 255;

int mul(int a, int b) {
    return (a * 1ll * b) % MOD;
}

int add(int a, int b) {
    long long r = a * 1ll + b;
    if (r >= MOD) {
        r -= MOD;
    }
    if (r < 0) {
        r += MOD;
    }
    return r;
}

class Mask {
public:
    void Add(char c) {
        ++Cnt_[c - 'a'];
    }

    void Clear() {
        memset(Cnt_, 0, sizeof(Cnt_));
    }

    long long Hash() {
        long long hsh = 0;
        for (char c = 'a'; c <= 'z'; ++c) {
            hsh = mul(hsh, BASE);
            hsh = add(hsh, Cnt_[c - 'a']);
        }
        return hsh;
    }

private:
    int Cnt_[26];
};

void solve() {
    string s;
    cin >> s;
    size_t size = s.size();
    Mask mask;
    for (size_t len = 1; len <= size; ++len) {
        if (size % len == 0) {
            size_t cnt = size / len;
            int hsh = -1;
            bool ok = true;

            vector<size_t> order(cnt);
            iota(order.begin(), order.end(), 0);
            random_shuffle(order.begin(), order.end());

            for (auto i : order) {
                mask.Clear();
                size_t off = i * len;
                for (size_t j = 0; j < len; ++j) {
                    mask.Add(s[off + j]);
                }
                if (hsh == -1) {
                    hsh = mask.Hash();
                } else if (hsh != mask.Hash()) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                cout << cnt << endl;
                return;
            }
        }
    }
    assert(false);
}


int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    BASE = 255 + rand() % 133;
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
