#include <bits/stdc++.h>

using namespace std;

string s;

const unsigned long long hash_base = 9999991UL;
const unsigned long long hash_mod  = 99999999977UL;
unsigned long long hash_powers[26];

inline unsigned long long modsum(unsigned long long a, unsigned long long b) {
	unsigned long long ret = a + b;
	if (ret > hash_mod) ret -= hash_mod;
	return ret;
}

inline void init_hash_powers() {
	hash_powers[0] = 1;
	for (int i = 1; i < 26; ++i) {
		hash_powers[i] = (hash_powers[i-1]*hash_base) % hash_mod;
	}
}

vector<unsigned long long> prefix_hash;

bool check(int n) {
	if (s.size() % n) return false;
	unsigned long long predicted_hash = 0;
	for (int i = n-1; i < s.size(); i += n) {
		predicted_hash = modsum(predicted_hash, prefix_hash[n-1]);
		if (prefix_hash[i] != predicted_hash) return false;
	}
	return true;
}

int main() {
	init_hash_powers();
	
	cin >> s;
	
	prefix_hash.resize(s.size());
	unsigned long long cur_hash = 0;
	for (int i = 0; i < s.size(); ++i) {
		cur_hash = modsum(hash_powers[s[i]-'a'], cur_hash);
		prefix_hash[i] = cur_hash;
	}

	for (int i = 1; i <= s.size(); ++i) {
		if (check(i)) {
			cout << s.size()/i << endl;
			break;
		}
	}
}
