import java.io.*;
import java.util.*;
import java.math.*;

public class om_sol_nloglogn_java implements Runnable {
  private static BufferedReader in;
  private static PrintWriter out;
  private static StringTokenizer st;
  private static Random rnd;
  private long hash_base = 9999991L;
  private long hash_mod  = 99999999977L;

  private long modsum(long a, long b) {
  	long ret = a + b;
  	if (ret > hash_mod) ret -= hash_mod;
  	return ret;
  }

  private void solve() throws IOException {
    String s = nextToken();
    long[] hash_powers = new long[26];
    hash_powers[0] = 1;
    for (int i = 1; i < 26; ++i) {
      hash_powers[i] = (hash_powers[i-1]*hash_base) % hash_mod;
    }
    long[] prefix_hash = new long[s.length()];
    long cur_hash = 0;
    for (int i = 0; i < s.length(); ++i) {
      cur_hash = modsum(hash_powers[s.charAt(i)-'a'], cur_hash);
      prefix_hash[i] = cur_hash;
    }

    for (int n = 1; n <= s.length(); ++n) {
      if (s.length() % n != 0) continue;
      long predicted_hash = 0;
      boolean ok = true;
      for (int i = n-1; i < s.length(); i += n) {
        predicted_hash = modsum(predicted_hash, prefix_hash[n-1]);
        if (prefix_hash[i] != predicted_hash) {
          ok = false;
          break;
        }
      }
      if (ok) {
        out.println(s.length() / n);
        break;
      }
    }

  }

  public static void main(String[] args) {
      new om_sol_nloglogn_java().run();
  }

  public void run() {
      try {
          in = new BufferedReader(new InputStreamReader(System.in));
          out = new PrintWriter(System.out);
          rnd = new Random();

          solve();

          out.close();
      } catch (IOException e) {
          e.printStackTrace();
          System.exit(42);
      }
  }

  private String nextToken() throws IOException {
      while (st == null || !st.hasMoreTokens()) {
          String line = in.readLine();

          if (line == null)
              return "";

          st = new StringTokenizer(line);
      }

      return st.nextToken();
  }
}
