#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 0
#endif
#define _unused __attribute__((unused))

struct frac {
    int num, den;

    frac(int _num, int _den) {
        int a = _num, b = _den;
        while (b != 0) {
            int tmp = a % b;
            a = b;
            b = tmp;
        }
        num = _num / a;
        den = _den / a;
    }

    struct hash {
        size_t operator()(const frac &f) const {
            return ((size_t) f.num << 32) | f.den;
        }
    };

    bool operator==(const frac &other) const {
        return num * 1LL * other.den == other.num * 1LL * den;
    }

    bool operator<(const frac &other) const {
        return num * 1LL * other.den < other.num * 1LL * den;
    }
};

int main() {
    string s;
    cin >> s;
    int n = s.length();

    int s_cnt[26];
    int c_cnt[26];
    memset(s_cnt, 0, sizeof s_cnt);
    memset(c_cnt, 0, sizeof c_cnt);

    int some_idx = -1;
    for (char c : s) {
        ++s_cnt[c - 'a'];
        some_idx = c - 'a';
    }

    unordered_set<frac, frac::hash> fracs;
    for (int i = 0; i < n; ++i) {
        ++c_cnt[s[i] - 'a'];
        char same_frac = 1;
        for (int j = 0; j < 26; ++j) {
            if (s_cnt[j] == 0)
                continue;
            if (c_cnt[j] * 1LL * s_cnt[some_idx] != c_cnt[some_idx] * 1LL * s_cnt[j]) {
                same_frac = 0;
                break;
            }
        }
        if (same_frac) {
            eprintf("%d %d\n", some_idx, s_cnt[some_idx]);
            fracs.emplace(c_cnt[some_idx], s_cnt[some_idx]);
        }
    }

    vector<frac> s_fracs;
    copy_if(fracs.begin(), fracs.end(), back_inserter(s_fracs), [](const frac &f) { return f.num == 1; });
    sort(s_fracs.begin(), s_fracs.end());
    for (auto i : s_fracs) {
        char all_present = 1;
        for (int num = 2; num <= i.den; ++num) {
            if (fracs.find(frac(num, i.den)) == fracs.end()) {
                all_present = 0;
                break;
            }
        }
        if (all_present) {
            printf("%d\n", i.den);
            return 0;
        }
    }
}
